# by_sort1.tcl --
#
#	This file implements package by_sort1, which  ...
#
#
#package require NAME VERSION
package provide by_sort1 1.0
#package require timers 1.0
#vpackage provide 
# Namespace out --
#
#   ADD COMMENTS HERE
#


namespace eval ::out {;
#namespace export -clear *
variable canv;
variable sfcol;
variable lsen;
variable olddelay4;
variable olddelay6
variable olddelayf;
variable olddelayfa;
variable olddelay5a;
variable olddelay3a;
variable olddelay5b;
variable olddelay3b

# init --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc init {nl} {
  variable canv;
  variable sfcol;
  variable lsen;
  variable olddelay4;
  variable olddelay6
  variable olddelayf;
  variable olddelayfa;
  variable olddelay5a;
  variable olddelay3a
  variable olddelay5b;
  variable olddelay3b;

    $canv delete all
    

    set sfcol(0) green;
    set sfcol(1) red;
    set lsen(0) red;
    set lsen(1) green;
    set lsen(2) black;
    set olddelay4  0;
    set olddelay6  0;
    set olddelayf  0;
    set olddelayfa 0;
    set olddelay5a 0;
    set olddelay3a 0;
    set olddelay5b 0;
    set olddelay3b 0;

###create basic tree of Mail Sorter

### Air Sensor
$canv create poly 80 50 120 50 120 70 80 70 -fill black
$canv create text 140 55 -text {Air Sensor} -anchor nw -justify left -fill  brown
$canv create text 225 55 -text ""  -anchor nw -justify left -fill blue -tags te(0)
$canv create text 215 30 -text "Activation"  -anchor nw -justify left -fill blue
$canv create text 290 30 -text "Termination"  -anchor nw -justify left -fill blue

###Solenoid 4 / Delay 4
$canv create line 100 70 100 90 -arrow last -fill blue -tags ar(0)
$canv create oval 90 90 110 110 -fill black
$canv create text 140 95  -text {Solenoid 4} -anchor nw -justify left -fill brown
$canv create text 225 95 -text ""  -anchor nw -justify left -fill blue -tags te(1)
$canv create text 140 75 -text {Delay4}  -anchor nw -justify left -fill red
$canv create text 225 75 -text ""  -anchor nw -justify left -fill blue -tags de(0)
$canv create text 300 75 -text ""  -anchor nw -justify left -fill blue -tags de(1)

###Letter Sensor 
$canv create line 100 110 100 150 -arrow last -fill blue -tags ar(1)
$canv create poly 80 150 120 150 120 170 80 170 -fill black
$canv create text 140 155 -text {Letter Sensor} -anchor nw -justify left -fill brown
$canv create text 225 155 -text ""  -anchor nw -justify left -fill blue -tags te(2)
$canv create text 140 125 -text {DelayF} -anchor nw -justify left -fill red
$canv create text 225 125 -text ""  -anchor nw -justify left -fill blue -tags de(2)
$canv create text 300 125 -text ""  -anchor nw -justify left -fill blue -tags de(3)

### Solenoid 5
$canv create line 100 170 100 190 -arrow last -fill blue -tags ar(2)
$canv create oval 90 190 110 210 -fill black
$canv create text 140 195  -text {Solenoid 5} -anchor nw -justify left -fill brown
$canv create text 225 195 -text ""  -anchor nw -justify left -fill blue -tags te(3)
$canv create text 140 175 -text {Delay5A} -anchor nw -justify left -fill red
$canv create text 225 175 -text ""  -anchor nw -justify left -fill blue -tags de(4)
$canv create text 300 175 -text ""  -anchor nw -justify left -fill blue -tags de(5)

### trays
$canv create line 100 210 60 250 -arrow last -fill blue -tags ar(3)
$canv create line 100 210 140 250 -arrow last -fill blue -tags ar(4)
$canv create text 60 265 -text {Airmail} -fill grey
$canv create text 140 265 -text {Non Airmail} -fill grey
$canv create text 140 220 -text {Delay5B} -anchor nw -justify left -fill red
$canv create text 225 220 -text ""  -anchor nw -justify left -fill blue -tags de(6)
$canv create text 300 220 -text ""  -anchor nw -justify left -fill blue -tags de(7)


### Class Sensor
$canv create poly 380 50 420 50 420 70 380 70 -fill black
$canv create text 440 55 -text {Class Sensor} -anchor nw -justify left -fill  brown
$canv create text 525 55 -text ""  -anchor nw -justify left -fill blue -tags cte(0)
$canv create text 515 30 -text "Activation"  -anchor nw -justify left -fill blue
$canv create text 590 30 -text "Termination"  -anchor nw -justify left -fill blue

###Solenoid 6 / Delay 6
$canv create line 400 70 400 90 -arrow last -fill blue -tags car(0)
$canv create oval 390 90 410 110 -fill black
$canv create text 440 95  -text {Solenoid 6} -anchor nw -justify left -fill brown
$canv create text 525 95 -text ""  -anchor nw -justify left -fill blue -tags cte(1)
$canv create text 440 75 -text {Delay6}  -anchor nw -justify left -fill red
$canv create text 525 75 -text ""  -anchor nw -justify left -fill blue -tags cde(0)
$canv create text 600 75 -text ""  -anchor nw -justify left -fill blue -tags cde(1)

###DelayFa 
$canv create line 400 110 400 160 -arrow last -fill blue -tags car(1)
#$canv create poly 80 150 120 150 120 170 80 170 -fill black
#$canv create text 140 155 -text {Letter Sensor} -anchor nw -justify left -fill brown
#$canv create text 225 155 -text ""  -anchor nw -justify left -fill blue -tags te(2)
$canv create text 440 125 -text {DelayFa} -anchor nw -justify left -fill red
$canv create text 525 125 -text ""  -anchor nw -justify left -fill blue -tags cde(2)
$canv create text 600 125 -text ""  -anchor nw -justify left -fill blue -tags cde(3)

### Solenoid 3
$canv create line 400 160 400 190 -arrow last -fill blue -tags car(2)
$canv create oval 390 190 410 210 -fill black
$canv create text 440 195  -text {Solenoid 3} -anchor nw -justify left -fill brown
$canv create text 525 195 -text ""  -anchor nw -justify left -fill blue -tags cte(3)
$canv create text 440 175 -text {Delay3A} -anchor nw -justify left -fill red
$canv create text 525 175 -text ""  -anchor nw -justify left -fill blue -tags cde(4)
$canv create text 600 175 -text ""  -anchor nw -justify left -fill blue -tags cde(5)

### trays
$canv create line 400 210 360 250 -arrow last -fill blue -tags car(3)
$canv create line 400 210 440 250 -arrow last -fill blue -tags car(4)
$canv create text 360 265 -text {1st Class} -fill grey
$canv create text 440 265 -text {2nd Class} -fill grey
$canv create text 440 220 -text {Delay3B} -anchor nw -justify left -fill red
$canv create text 525 220 -text ""  -anchor nw -justify left -fill blue -tags cde(6)
$canv create text 600 220 -text ""  -anchor nw -justify left -fill blue -tags cde(7)


}

proc showairsensor {nl} {
    variable canv;

    set lair [lindex $nl 0]
    set ct     [lindex $nl 1]

    $canv itemconfigure te(0) -text $ct

    if {$lair == 0 } {
      $canv create poly 80 50 120 50 120 70 80 70 -fill red
      $canv create text 100 60 -text {nAir} -fill blue
    } else {
       if {$lair == 1 } {     
        $canv create poly 80 50 120 50 120 70 80 70 -fill green
        $canv create text 100 60 -text {Air} -fill blue
       } else {
         $canv create poly 80 50 120 50 120 70 80 70 -fill black
       }
    }


}

proc showsolefour {nl} {
    variable canv;
    variable sfcol;

    set so4 [lindex $nl 0]
    set ct  [lindex $nl 1]

    $canv itemconfigure te(1) -text $ct

    $canv create oval 90 90 110 110 -fill $sfcol($so4)
}


proc showlettersensor {nl} {
    variable canv;
    variable lsen;

    set lletter [lindex $nl 0]
    set ct      [lindex $nl 1]

    $canv itemconfigure te(2) -text $ct

    $canv create poly 80 150 120 150 120 170 80 170 -fill $lsen($lletter)

}


proc showsolefive {nl} {
    variable canv;
    variable sfcol;

    set so5 [lindex $nl 0]
    set ct  [lindex $nl 1]

    $canv itemconfigure te(3) -text $ct

    $canv create oval 90 190 110 210 -fill red -fill $sfcol($so5)

    if {$so5 == 0 } {
        $canv create text 60 265 -text {Airmail} -fill red
        $canv create text 140 265 -text {Non Airmail} -fill grey
    } else {
        $canv create text 140 265 -text {Non Airmail} -fill red
        $canv create text 60 265 -text {Airmail} -fill grey
    }
}

proc showdelayfour {nl} {
    variable canv;
    variable olddelay4;

    set dt4 [lindex $nl 0]
    set de4 [lindex $nl 1]

    if {$dt4 == 0} {
        set olddelay4 $de4;
        
        $canv itemconfigure de(0) -text $de4
        $canv itemconfigure ar(0) -fill yellow
    } else {
        $canv itemconfigure de(1) -text $de4
        $canv itemconfigure ar(0) -fill blue
    }

}
 

proc showdelayF {nl} {
    variable canv;
    variable olddelayf;

    set dtf [lindex $nl 0]
    set dlf [lindex $nl 1]

    if {$dtf == 0} {
        set olddelayf $dlf;
        
        $canv itemconfigure de(2) -text $dlf
        $canv itemconfigure ar(1) -fill yellow
    } else {
        $canv itemconfigure de(3) -text $dlf
        $canv itemconfigure ar(1) -fill blue
    }

}

proc showdelayfiveA {nl} {
    variable canv;
    variable olddelay5a;

    set dta [lindex $nl 0]
    set dla [lindex $nl 1]

    if {$dta == 0} {
        set olddelay5a $dla;
        
        $canv itemconfigure de(4) -text $dla
        $canv itemconfigure ar(2) -fill yellow
    } else {
        $canv itemconfigure de(5) -text $dla
        $canv itemconfigure ar(2) -fill blue
    }

}

proc showdelay {nl} {
    variable canv;

    set nd [lindex $nl 0]
     
     $canv itemconfigure de(4) -text ""
     $canv itemconfigure de(5) -text ""
     $canv itemconfigure de(6) -text ""
     $canv itemconfigure de(7) -text ""
     $canv itemconfigure te(3) -text ""
     $canv itemconfigure ar(2) -fill yellow   
     if {$nd == 1} {
          $canv itemconfigure ar(3) -fill yellow
        } else {
          $canv itemconfigure ar(4) -fill yellow
        }
}

proc noshowdelay {nl} {
    variable canv;
      
    set nd [lindex $nl 0]  
    $canv itemconfigure ar(2) -fill blue   
    if {$nd == 1} {
          $canv itemconfigure ar(3) -fill blue
        } else {
          $canv itemconfigure ar(4) -fill blue
        }    
        
}

proc showdelayfiveB {nl} {
    variable canv;
    variable olddelay5b;

    set dtb [lindex $nl 0]
    set dtc [lindex $nl 1]
    set dlb [lindex $nl 2]

    if {$dtb == 0} {
        set olddelay5b $dlb;
        
        $canv itemconfigure de(6) -text $dlb
        if {$dtc == 0} {
          $canv itemconfigure ar(3) -fill yellow
        } else {
          $canv itemconfigure ar(4) -fill yellow
        }
        
    } else {
        $canv itemconfigure de(7) -text $dlb
        if {$dtc == 0} {
          $canv itemconfigure ar(3) -fill blue
        } else {
          $canv itemconfigure ar(4) -fill blue
        }
    }

}


proc showclasssensor {nl} {
    variable canv;

    set lclass [lindex $nl 0]
    set ct     [lindex $nl 1]

    $canv itemconfigure cte(0) -text $ct

    if {$lclass == 0 } {
      $canv create poly 380 50 420 50 420 70 380 70 -fill black
    } else {
       if {$lclass == 1 } {     
        $canv create poly 380 50 420 50 420 70 380 70 -fill green
        $canv create text 400 60 -text {1st} -fill blue
       } else {
         $canv create poly 380 50 420 50 420 70 380 70 -fill red
         $canv create text 400 60 -text {2nd} -fill blue
       }
    }


}

proc showsolesix {nl} {
    variable canv;
    variable sfcol;

    set so6 [lindex $nl 0]
    set ct  [lindex $nl 1]

    $canv itemconfigure cte(1) -text $ct

    $canv create oval 390 90 410 110 -fill $sfcol($so6)
}

proc showsolethree {nl} {
    variable canv;
    variable sfcol;

    set so3 [lindex $nl 0]
    set ct  [lindex $nl 1]

    $canv itemconfigure cte(3) -text $ct

    $canv create oval 390 190 410 210 -fill red -fill $sfcol($so3)

    if {$so3 == 0 } {
        $canv create text 360 265 -text {1st Class} -fill red
        $canv create text 440 265 -text {2nd Class} -fill grey
    } else {
        $canv create text 440 265 -text {2nd Class} -fill red
        $canv create text 360 265 -text {1st Class} -fill grey
    }
}

proc showdelaysix {nl} {
    variable canv;
    variable olddelay6;

    set dt6 [lindex $nl 0]
    set de6 [lindex $nl 1]

    if {$dt6 == 0} {
        set olddelay6 $de6;
        
        $canv itemconfigure cde(0) -text $de6
        $canv itemconfigure car(0) -fill yellow
    } else {
        $canv itemconfigure cde(1) -text $de6
        $canv itemconfigure car(0) -fill blue
    }

}

proc showdelayFa {nl} {
    variable canv;
    variable olddelayfa;

    set dtf [lindex $nl 0]
    set dlf [lindex $nl 1]

    if {$dtf == 0} {
        set olddelayfa $dlf;
        
        $canv itemconfigure cde(2) -text $dlf
        $canv itemconfigure car(1) -fill yellow
    } else {
        $canv itemconfigure cde(3) -text $dlf
        $canv itemconfigure car(1) -fill blue
    }

}

proc showdelaythreeA {nl} {
    variable canv;
    variable olddelay3a;

    set dta [lindex $nl 0]
    set dla [lindex $nl 1]

    if {$dta == 0} {
        set olddelay3a $dla;
        
        $canv itemconfigure cde(4) -text $dla
        $canv itemconfigure car(2) -fill yellow
    } else {
        $canv itemconfigure cde(5) -text $dla
        $canv itemconfigure car(2) -fill blue
    }

}

proc cshowdelay {nl} {
    variable canv;

    set nd [lindex $nl 0]
     
     $canv itemconfigure cde(4) -text ""
     $canv itemconfigure cde(5) -text ""
     $canv itemconfigure cde(6) -text ""
     $canv itemconfigure cde(7) -text ""
     $canv itemconfigure cte(3) -text ""
     $canv itemconfigure car(2) -fill yellow   
     if {$nd == 1} {
          $canv itemconfigure car(3) -fill yellow
        } else {
          $canv itemconfigure car(4) -fill yellow
        }
}

proc cnoshowdelay {nl} {
    variable canv;
      
    set nd [lindex $nl 0]  
    $canv itemconfigure car(2) -fill blue   
    if {$nd == 1} {
          $canv itemconfigure car(3) -fill blue
        } else {
          $canv itemconfigure car(4) -fill blue
        }    
        
}

proc showdelaythreeB {nl} {
    variable canv;
    variable olddelay3b;

    set dtb [lindex $nl 0]
    set dtc [lindex $nl 1]
    set dlb [lindex $nl 2]

    if {$dtb == 0} {
        set olddelay3b $dlb;
        
        $canv itemconfigure cde(6) -text $dlb
        if {$dtc == 0} {
          $canv itemconfigure car(3) -fill yellow
        } else {
          $canv itemconfigure car(4) -fill yellow
        }
        
    } else {
        $canv itemconfigure cde(7) -text $dlb
        if {$dtc == 0} {
          $canv itemconfigure car(3) -fill blue
        } else {
          $canv itemconfigure car(4) -fill blue
        }
    }

}

}; #end of namespace by_sort1






