/* -*- Mode: C -*-
 * fac.t 
 * program to check the invariant of the factorial program fac
 * which is started when this file is loaded
 *
 */
 
load "../library/conversion".
load "../library/exprog".

/* prog fac 0 */

set print_states = false.

define seed = 1+ random mod 9.

define get_var(X,Y) = 
{
    exists T : {
        get2(T) and output(atime(T)) and
        if avar(T)=X then {Y=strint(aval(T))}        
        else empty
    }
}.

define check(Z,X,Y) = {
    {
        skip and get_var("fac",X) and stable(X) and
        if X= Z then {
          format("!:: Pass Prog %7d Prop %7d\n", X, Z)
        } else {
          format("!:: Fac: Prog %d Prop %d\n", X, Z)
        }
    };
    { skip and get_var("y",Y) and  stable(X) and stable(Y)
          };
    {
        skip and  stable(Y)
            }
    
    
}.



define fac_rel(Y) = {
   if Y=seed then Y
          else Y * fac_rel(Y+1)
}.

/* run */ define test() = {
  exists Fac,Y : {
     prog_send(seed);
     check(1,Fac,Y); 
    if seed>1 then {
        while Y>1 do
            check(fac_rel(Y),Fac,Y)
    } else empty
  }
}.





