/* -*- Mode: C -*-
 * tempura library defining various TAM constructs
 *
 */

define chan(X) = { list(X, 3) and stable(struct(X)) }.

define wtr(C) = { C[0] }.

define wtw(C) = { C[1] }.

define val(C) = { C[2] }.

define comr(C,X) = { X = C[2] and wtr(C)=1  }.

define comw(C,X) = {  wtw(C)=1 and C[2] = X }.

define rdc(C,X) = { wtr(C)=1 and
  if wtr(C)=1 and wtw(C)=1 then comr(C,X)
  else { {wtr(C)=1 and wtw(C)=0 and stable(C)};skip;comr(C,X) }
}.

define wrc(C,X) = { wtw(C)=1 and
  if wtr(C)=1 and wtw(C)=1 then comw(C,X)
  else { {wtr(C)=0 and wtw(C)=1 and stable(C)};skip;comw(C,X) }
}.

define trdc(C,d,X) = {
  rdc(C,X) and len(d)
}.

define twrc(C,d,X) = {
  wrc(C,X) and len(d)
}.


define shunt(X) = { list(X, 2) and stable(struct(X)) }.

define stmp(S) = { S[0] }.

define rds(S) = { S[1] }. 

define wrs(S,X) = { 
  skip and S[0] := S[0] +1 and S[1] := X 
}.

define swrs(S,X) = { 
   S[0] := S[0] +1 and S[1] := X 
}.

define twrs(S,d,X) = {
 len(d-1) ; wrs(S,X)
}.

define delay(d) = { len(d) }.

