/* -*- Mode: C -*-
 * Miscellaneous functions for C interpreter.
 * Roger Hale
 */

define is_integer(A) = {
    type(A) = "integer"
}.

define is_boolean(A) = {
    type(A) = "boolean"
}.

define is_nil(A) = {
    type(A) = "nil"
}.

define is_list(A) = {
    type(A) = "list"
}.

define is_string(A) = {
    type(A) = "string"
}.

define is_pointer(A) = {
    type(A) = "pointer"
}.

define is_lambda(A) = {
    type(A) = "lambda"
}.

define is_digit(S) = {
    "0" <= S and S <= "9"
}.

define wave(A) = {
    if A=0 then "|  " else "  |"
}.

define keep_stable(X) = exists x:{keep(X=x)}.
