/* -*- Mode: C -*-
 * Simple example of projection.   
 * Ben Moszkowski.  
 * 3 Apr 85
 * Updated 19 Aug 85. 
 */

/* Requires set(future_asgn_flag,false) */

define body(I,J) = {
    (I=0) and (I gets I+1) and (J=0) and (J gets J+I) and halt (I=4)
}.

/* run */ define simple_proj_test() = exists I,J: {
    {
	{(skip and stable I and stable J) ; skip}
        proj 
	body(I,J)
    }
    and always format("I=%3d  J=%3d\n",I,J)
}.

/* run */ define var_proj_test() = exists I,J: {
    {{
	(len(I) and stable I and stable J);
	skip
    } proj {
	body(I,J)
    }
    }
    and always format("I=%3d  J=%3d\n",I,J)
}.
