/* -*- Mode: C -*-                             
 * queue.t
 */


define append(L1,L2) = {  L1 + L2 }.

define first(L) = { if L=[] then [] else L[0] }.

define suf_rest(L) = { if L=[] then [] else L[1..|L|] }.

define last(L) = { if L=[] then [] else L[|L|-1] }.

define pref_rest(L) = { if L=[] then [] else L[0..|L|-1] }.


/* run */ define queue_test() = {
    exists L,X,Y : {
        L=[] and
        always {
            format("L=%12t\n",L) and
            input X and
            if X=1 then {
                input Y and
                L:=append(L,[Y]) and
                format("adding %t at the end of the queue\n",Y)
            }
            else if X=2 then {
                input Y and
                L:=append([Y],L) and
                format("adding %t to the front of the queue\n",Y)
            }
            else if X=3 then {
                if last(L)=[] then {
                    format("there is no last element in  an empty queue\n")
                }
                else {
                    format("removing last element %t of queue\n", last(L)) and
                    L:=pref_rest(L)
                }
            }
            else if X=4 then {
                if first(L)=[] then {
                    format("there is no first element in an empty queue\n")
                }
                else {
                    format("removing first element %t of queue\n", first(L))
                    and L:=suf_rest(L)
                }
            }
            else {
                empty
            }
        }
    }
}.



