/* -*- Mode: C -*-
 * abp.t --- alternating bit protocol
 *
 */

load "../library/tam".

define chanbehD =    [0,1,0,0,1,0,1,1,1,1,1,1].

define chanbehAck =  [1,0,1,1,1,1,0,0,1,1,1,1].

/* run */ define abp() = {

  exists D, Ack, Cs, Sendbuff, Data, I, Cn, Cr, Ind : {
   chan(D) and chan(Ack) and

define produce() = {
   Cs := (Cs + 1) mod 2 and
   Data := Data + 1 and
   Sendbuff:= Data
 }
  and
define sendD() = {
   format("sending   over D  %t\n", [Sendbuff,(Cs-1) mod 2]) and
   if chanbehD[Ind] = 1 then {
     wrc(D,[Sendbuff,(Cs-1) mod 2])
   } else {
     wrc(D,[-1,-1])
   }
 }
  and
define recack() = {
   rdc(Ack,Cn) and
   if Cn ~=-1 then {
     format("receiving over Ack %t\n",Cn) and
     if Sendbuff ~= -1 and Cs = Cn then {
        Sendbuff := -1 and
        format("Ack is ok\n")
     }
      else {
        Sendbuff := Sendbuff and
        format("Ack is not ok, resending\n")
      }
   } else {
     Sendbuff := Sendbuff and
        format("Ack is lost, resending\n")
     }
 }
  and
define recD() = {
   rdc(D,I) and
   if I[1] ~= -1 then {
     format("receiving over D  %t\n",I) and
     if Cr = I[1] then { 
       if chanbehAck[Ind]=1 then {
         wrc(Ack,(Cr + 1) mod 2) 
       } else {
         wrc(Ack,-1)
       } and Cr:=(Cr + 1) mod 2 and
       format("Data over D is ok\n") and
       format("consume                           %t\n", I[0]) and
       format("sending   over Ack %t\n",(Cr + 1) mod 2)
     }
      else {
       if chanbehAck[Ind]=1 then {
         wrc(Ack,Cr)
       } else {
         wrc(Ack,-1)
       } and Cr:=Cr and
       format("Data over D is not ok\n") and
       format("sending   over Ack %t\n",Cr)
      }
    } else {
       if chanbehAck[Ind]=1 then {
         wrc(Ack,Cr)
       } else {
          wrc(Ack,-1)
       } and Cr:=Cr and
       format("Data over D is lost\n") and
       format("sending   over Ack %t\n",Cr)
      }
    
 }
 and  Cs = 0 and Sendbuff = -1 and Cr = 0 and  Data = 0 and
 Ind = 0 and
 format("Channel behavior D   %t\n",chanbehD) and
 format("Channel behavior Ack %t\n",chanbehAck) and
 while Ind < |chanbehD| do {
    skip and  
   if Sendbuff ~= -1 then {
    Ind:=Ind+1 and
    sendD() and
    recD() and
    recack() and
    stable(Cs) and
    stable(Data)
   }
    else {
     format("produce                           %t\n", Data) and
     stable(Cr) and
     stable(Ind) and
     produce()
   }
 }
 }
}.

