/* -*- Mode: C -*-
 * check ex0.v verilog prog
 *
 */

load "../library/conversion".
load "../library/exveri".
/* veri ex0.v 0 */
/* vdmp ex0.dmp */

set print_states = false.

define check_reg(X,Y) = {
   get(X) and 
   if avar(X)="R" then {
    if  strint(aval(X))=Y and atime(X)=2*strint(aval(X)) then {
     format("!%d:: Pass Reg test %d\n", atime(X), Y)
    } else {
     format("!%d:: Reg Prog %d, Real %d\n",atime(X), Y, strint(aval(X)))
      }
    } else {
       format("!%d:: Reg %d: Wrong input received %s\n",atime(X), Y, aval(X))
    }
}.

/* run */ define test() = {
    exists X,Y :{
      {Y=1 and veri_dot()};{skip and stable(Y)};
     while Y<=10 do {
      {check_reg(X,Y)};{skip and stable(Y)};
      {skip and Y:=Y+1};{skip and stable(Y)}
     }
  }
}.
    
    
