# epsimnew.tcl --
#
#	This file implements package lifts-simple, which  ...
#
# Copyright (c) 1998-1999 Antonio Cau
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 

#package require NAME VERSION
package provide epsimnew 1.0
# Namespace out --
#
#   ADD COMMENTS HERE
#
namespace eval ::out {;
#namespace export -clear *
variable msize;
variable canv;
variable col;
variable noslots;

# init --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc init {nl} {
  variable msize;
  variable noslots;
  variable canv;
  variable col;
  
    
    set msize   [lindex $nl 0];
    set noslots [lindex $nl 1];
    set col(0) red;
    set col(1) green;
    set col(2) SkyBlue;
    set col(3) bisque;
    set col(4) yellow;
    set col(5) black;
    

    $canv delete all

    wm geometry .top23 800x345+1+20
   
    $canv create text 40 15 -text Cycle -font {7x13bold}
    $canv create text 40 30 -text nv -font {7x13bold} -tags inf(0)
    $canv create text 100 15 -text Proccycle -font {7x13bold} 
    $canv create text 100 30 -text nv -font {7x13bold} -tags inf(1)
    $canv create text 160 15 -text Riopsta -font {7x13bold} 
    $canv create text 160 30 -text nv -font {7x13bold} -tags inf(2)
#    $canv create text 220 15 -text Zilocka -font {7x13bold}
#    $canv create text 220 30 -text nv -font {7x13bold} -tags inf(3)
#    $canv create text 280 15 -text Zilockb -font {7x13bold}
#    $canv create text 280 30 -text nv -font {7x13bold} -tags inf(4)
#    $canv create text 340 15 -text Ziopreq -font {7x13bold}
#    $canv create text 340 30 -text nv -font {7x13bold} -tags inf(5)
#    $canv create text 400 15 -text Zvalid -font {7x13bold} 
#    $canv create text 400 30 -text nv -font {7x13bold} -tags inf(6) 
    $canv create text 220 15 -text ISSdest -font {7x13bold} 
    $canv create text 220 30 -text nv -font {7x13bold} -tags inf(7) 
#    $canv create text 280 15 -text Step -font {7x13bold}
#    $canv create text 280 30 -text nv -font {7x13bold} -tags inf(4)

    $canv create rect \
       10 64 \
      590 90 \
      -outline $col(1) -width 1 -tags pipe(0)
    $canv create rect \
       10 94 \
      520 120 \
      -outline $col(1) -width 1 -tags pipe(1)

    $canv create rect \
      620 94 \
      670 140 \
      -outline $col(1) -fill $col(3) -width 1 -tags pipe(5)

    $canv create text \
      640 117 -text IO -font {7x13bold} 

    $canv create line \
      520 98 \
      620 98 \
     -fill $col(0) -arrow last -tags lico(0)

    $canv create line \
      520 104 \
      550 104 \
      550 111 \
      620 111 \
     -fill $col(0) -arrow last -tags lico(1)

    $canv create text \
      590 111 -text Zvalid -fill $col(5) -font {7x13bold}
  
    $canv create line \
      520 110 \
      540 110 \
      540 124 \
      620 124 \
     -fill $col(0) -arrow first -tags lico(2)

    $canv create text \
      590 124 -text Ziopreq -fill $col(5) -font {7x13bold}

    $canv create line \
      520 116 \
      530 116 \
      530 137 \
      620 137 \
     -fill $col(0) -arrow first -tags lico(3)

    $canv create oval \
      700 104 \
      706 110 \
     -fill $col(0) -tags ovco

    $canv create line \
       605 98 \
       605 88 \
       703 88 \
       703 104 \
     -fill $col(0) -arrow last -tags lico(4)

    $canv create text \
      655 84 -text Zilockb -fill $col(5) -font {7x13bold}

     $canv create line \
       605 137 \
       605 147 \
       703 147 \
       703 110 \
     -fill $col(0) -arrow last -tags lico(5) 

     $canv create text \
      655 151 -text Zilocka -fill $col(5) -font {7x13bold}    
    
     $canv create line \
       706 107 \
       720 107 \
     -fill $col(0) -arrow none -tags lico(6)

     $canv create line \
       720 107 \
       720 68 \
       590 68 \
     -fill $col(0) -arrow last -tags lico(7)

    $canv create line \
       720 107 \
       720 206 \
       590 206 \
     -fill $col(0) -arrow last -tags lico(8)
     


    $canv create rect \
       10 124 \
      520 150 \
      -outline $col(1) -width 1 -tags pipe(2)
    $canv create rect \
       10 154 \
      590 180 \
      -outline $col(1) -width 1 -tags pipe(3)
    $canv create rect \
       10 184 \
      590 210 \
      -outline $col(1) -width 1 -tags pipe(4)

    $canv create line \
        130 64 \
        130 90 \
        -fill $col(1) -tags pipeli(0)
    $canv create line \
        200 64 \
        200 90 \
        -fill $col(1) -tags pipeli(0)
    $canv create line \
        280 64 \
        280 90 \
        -fill $col(1) -tags pipeli(0)
    $canv create line \
        360 64 \
        360 90 \
        -fill $col(1) -tags pipeli(0)
    $canv create line \
        440 64 \
        440 90 \
        -fill $col(1) -tags pipeli(0)
    $canv create line \
        520 64 \
        520 90 \
        -fill $col(1) -tags pipeli(0)

    $canv create line \
        130 94 \
        130 120 \
        -fill $col(1) -tags pipeli(1)
    $canv create line \
        200 94 \
        200 120 \
        -fill $col(1) -tags pipeli(1)
    $canv create line \
        280 94 \
        280 120 \
        -fill $col(1) -tags pipeli(1)
    $canv create line \
        360 94 \
        360 120 \
        -fill $col(1) -tags pipeli(1)
    $canv create line \
        440 94 \
        440 120 \
        -fill $col(1) -tags pipeli(1)
    $canv create line \
        520 94 \
        520 120 \
        -fill $col(1) -tags pipeli(1)

    $canv create line \
        130 124 \
        130 150 \
        -fill $col(1) -tags pipeli(2)
    $canv create line \
        200 124 \
        200 150 \
        -fill $col(1) -tags pipeli(2)
    $canv create line \
        280 124 \
        280 150 \
        -fill $col(1) -tags pipeli(2)
    $canv create line \
        360 124 \
        360 150 \
        -fill $col(1) -tags pipeli(2)
    $canv create line \
        440 124 \
        440 150 \
        -fill $col(1) -tags pipeli(2)
    $canv create line \
        520 124 \
        520 150 \
        -fill $col(1) -tags pipeli(2)
   
    $canv create line \
        130 154 \
        130 180 \
        -fill $col(1) -tags pipeli(3)
    $canv create line \
        200 154 \
        200 180 \
        -fill $col(1) -tags pipeli(3)
    $canv create line \
        280 154 \
        280 180 \
        -fill $col(1) -tags pipeli(3)
    $canv create line \
        360 154 \
        360 180 \
        -fill $col(1) -tags pipeli(3)
    $canv create line \
        440 154 \
        440 180 \
        -fill $col(1) -tags pipeli(3)
    $canv create line \
        520 154 \
        520 180 \
        -fill $col(1) -tags pipeli(3)

    $canv create line \
        130 184 \
        130 210 \
        -fill $col(1) -tags pipeli(4)
    $canv create line \
        200 184 \
        200 210 \
        -fill $col(1) -tags pipeli(4)
    $canv create line \
        280 184 \
        280 210 \
        -fill $col(1) -tags pipeli(4)
    $canv create line \
        360 184 \
        360 210 \
        -fill $col(1) -tags pipeli(4)
    $canv create line \
        440 184 \
        440 210 \
        -fill $col(1) -tags pipeli(4)
    $canv create line \
        520 184 \
        520 210 \
        -fill $col(1) -tags pipeli(4)

    $canv create text\
      240 55 -text F3 -justify left -font {7x13bold}
    $canv create text\
      320 55 -text F2 -justify left -font {7x13bold}
    $canv create text\
      400 55 -text F1 -justify left -font {7x13bold}
    $canv create text\
      480 55 -text F0 -justify left -font {7x13bold}

    $canv create text 70 77 -text nv \
      -justify left -font {7x13bold} -tags pipea(0)
    $canv create text 165 77 -text ALU1 \
      -justify left -font {7x13bold}
    $canv create text 240 77 -text nv \
      -justify left -font {7x13bold} -tags pipeafl(3)   
    $canv create text 320 77 -text nv \
      -justify left -font {7x13bold} -tags pipeafl(2)
    $canv create text 400 77 -text nv \
      -justify left -font {7x13bold} -tags pipeafl(1)
    $canv create text 480 77 -text nv \
      -justify left -font {7x13bold} -tags pipeafl(0)
    $canv create text 560 55 -text B  \
      -justify left -font {7x13bold} 
    $canv create text 560 77 -text nv \
      -justify left -font {7x13bold} -tags pipea(3)

    $canv create text 70 107 -text nv \
      -justify left -font {7x13bold} -tags pipeb(0)
    $canv create text 165 107 -text ISS/ALU2 \
      -justify left -font {7x13bold}
    $canv create text 240 107 -text nv \
      -justify left -font {7x13bold} -tags pipebfl(3)
    $canv create text 320 107 -text nv \
      -justify left -font {7x13bold} -tags pipebfl(2)
    $canv create text 400 107 -text nv \
      -justify left -font {7x13bold} -tags pipebfl(1)
    $canv create text 480 107 -text nv \
      -justify left -font {7x13bold} -tags pipebfl(0)

    $canv create text 70 137 -text nv \
      -justify left -font {7x13bold} -tags pipec(0)
    $canv create text 165 137 -text MEM1 \
      -justify left -font {7x13bold}
    $canv create text 240 137 -text nv \
      -justify left -font {7x13bold} -tags pipecfl(3)
    $canv create text 320 137 -text nv \
      -justify left -font {7x13bold} -tags pipecfl(2)
    $canv create text 400 137 -text nv \
      -justify left -font {7x13bold} -tags pipecfl(1)
    $canv create text 480 137 -text nv \
      -justify left -font {7x13bold} -tags pipecfl(0)
    
    $canv create text 70 167 -text nv \
      -justify left -font {7x13bold} -tags piped(0)
    $canv create text 165 167 -text MEM2 \
      -justify left -font {7x13bold}
    $canv create text 240 167 -text nv \
      -justify left -font {7x13bold} -tags pipedfl(3)
    $canv create text 320 167 -text nv \
      -justify left -font {7x13bold} -tags pipedfl(2)
    $canv create text 400 167 -text nv \
      -justify left -font {7x13bold} -tags pipedfl(1)
    $canv create text 480 167 -text nv \
      -justify left -font {7x13bold} -tags pipedfl(0) 
    $canv create text 560 167 -text nv \
      -justify left -font {7x13bold} -tags piped(3)

    $canv create text\
       70 197 -text nv -justify left -font {7x13bold} -tags pipee(0)
    $canv create text\
      165 197 -text STACK -justify left -font {7x13bold}
    $canv create text\
      240 197 -text nv -justify left -font {7x13bold} -tags pipeefl(3)
    $canv create text\
      320 197 -text nv -justify left -font {7x13bold} -tags pipeefl(2)
    $canv create text\
      400 197 -text nv -justify left -font {7x13bold} -tags pipeefl(1)
    $canv create text\
      480 197 -text nv -justify left -font {7x13bold} -tags pipeefl(0) 
    $canv create text\
      560 197 -text nv -justify left -font {7x13bold} -tags pipee(3)

    for {set i 0} {$i<[expr $noslots+1]} {incr i} { 
      $canv create text 70 [expr 220+$i*9] -text "" \
        -justify left -font {7x13bold} -tags stka($i)
      $canv create text 165 [expr 220+$i*9] -text $i \
        -justify left -font {7x13bold} -tags stki($i)
      $canv create text 240 [expr 220+$i*9] -text "" \
        -justify left -font {7x13bold} -tags stkb($i)
      $canv create text 320 [expr 220+$i*9] -text "" \
        -justify left -font {7x13bold} -tags stkc($i)
      $canv create text 400 [expr 220+$i*9] -text "" \
        -justify left -font {7x13bold} -tags stkd($i)
      $canv create text 480 [expr 220+$i*9] -text "" \
        -justify left -font {7x13bold} -tags stke($i) 
      $canv create text 560 [expr 220+$i*9] -text "" \
        -justify left -font {7x13bold} -tags stkf($i)
    }        

    $canv create text 700 220 -text "" \
      -justify left -font {7x13bold} -tags mm(2)
    $canv create text 700 230 -text "" \
      -justify left -font {7x13bold} -tags mm(0)
    $canv create text 700 240 -text "" \
      -justify left -font {7x13bold} -tags mm(1)
}



# wmem --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc wmem {nl} {
  variable  msize;
  variable  noslots;
  variable  canv;
  variable  col;

  set ma [lindex $nl 0];
  set va [lindex $nl 1];
  
  $canv itemconfigure mm(2) -text "Writing"
  $canv itemconfigure mm(0) -text "to Mem: 0000$ma"
  $canv itemconfigure mm(1) -text "the value $va"
}

# cmem --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc cmem {nl} {
  variable  msize;
  variable  noslots;
  variable  canv;
  variable  col;
  
  $canv itemconfigure mm(2) -text ""
  $canv itemconfigure mm(0) -text ""
  $canv itemconfigure mm(1) -text ""
}


# rmem --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc rmem {nl} {
  variable  msize;
  variable  noslots;
  variable  canv;
  variable  col;

  set ma [lindex $nl 0];
  set va [lindex $nl 1];
  
  $canv itemconfigure mm(2) -text "Reading"
  $canv itemconfigure mm(0) -text "from Mem: 0000$ma"
  $canv itemconfigure mm(1) -text "the value $va"
}



# info --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc info {nl} {
  variable  msize;
  variable  noslots;
  variable  canv;
  variable  col;

  set cycle     [lindex $nl 0];
  set proccycle [lindex $nl 1];
  set riopsta   [lindex $nl 2];
  set zilocka   [lindex $nl 3];
  set zilockb   [lindex $nl 4];
  set ziopreq   [lindex $nl 5];
  set zvalid    [lindex $nl 6];
    
  $canv itemconfigure inf(0) -text $cycle 
  $canv itemconfigure inf(1) -text $proccycle
  $canv itemconfigure inf(2) -text $riopsta
#  $canv itemconfigure inf(3) -text $zilocka
#  $canv itemconfigure inf(4) -text $zilockb 
#  $canv itemconfigure inf(5) -text $ziopreq
#  $canv itemconfigure inf(6) -text $zvalid

  $canv itemconfigure lico(0) -fill $col($zilockb)
  $canv itemconfigure lico(4) -fill $col($zilockb)
  $canv itemconfigure lico(3) -fill $col($zilocka)
  $canv itemconfigure lico(5) -fill $col($zilocka)
  $canv itemconfigure lico(1) -fill $col($zvalid)
  $canv itemconfigure lico(2) -fill $col($ziopreq)
    if {$zilockb == 1 || $zilocka == 1} {
  $canv itemconfigure lico(6) -fill $col(1) 
  $canv itemconfigure lico(7) -fill $col(1)
  $canv itemconfigure lico(8) -fill $col(1)
    } else {
  $canv itemconfigure lico(6) -fill $col(0) 
  $canv itemconfigure lico(7) -fill $col(0)
  $canv itemconfigure lico(8) -fill $col(0)
    }
}



# pipezero --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc pipezero {nl} {
  variable  msize;
  variable  noslots;
  variable  canv;
  variable  col;

  set raluonein [lindex $nl 0];
  set raluones  [lindex $nl 1];
  set raluonea  [lindex $nl 2];
  set raluoneb  [lindex $nl 3];

    
  $canv itemconfigure pipe(0) -outline $col($raluones)  
  $canv itemconfigure pipeli(0) -fill $col($raluones) 
    if {$raluones == 1} { 
      $canv itemconfigure pipe(0) -fill $col(3)
      $canv itemconfigure pipea(0) -text $raluonein  -justify left
#      $canv itemconfigure pipea(1) -text $raluones -justify left
      $canv itemconfigure pipeafl(3) -text [string range $raluonea 0 7]
      $canv itemconfigure pipeafl(2) -text [string range $raluonea 8 15]
      $canv itemconfigure pipeafl(1) -text [string range $raluonea 16 23]
      $canv itemconfigure pipeafl(0) -text [string range $raluonea 24 31]
      $canv itemconfigure pipea(3) -text $raluoneb -justify left
    } else {
      $canv itemconfigure pipe(0) -fill $col(2)
      $canv itemconfigure pipea(0) -text ""  -justify left
#      $canv itemconfigure pipea(1) -text "" -justify left
      $canv itemconfigure pipeafl(3) -text ""
      $canv itemconfigure pipeafl(2) -text ""
      $canv itemconfigure pipeafl(1) -text ""
      $canv itemconfigure pipeafl(0) -text ""
      $canv itemconfigure pipea(3) -text "" -justify left
    }
}


# pipeone --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc pipeone {nl} {
  variable msize;
  variable noslots;
  variable canv;
  variable col;

  set riione     [lindex $nl 0];
  set riiones    [lindex $nl 1];
  set ralutwo    [lindex $nl 2];
  set riionedest [lindex $nl 3];

   
  $canv itemconfigure pipe(1) -outline $col($riiones)
  $canv itemconfigure pipeli(1) -fill $col($riiones)
  $canv itemconfigure inf(7) -text $riionedest -justify left 
  if {$riiones == 1} {  
  $canv itemconfigure pipe(1) -fill $col(3)
  $canv itemconfigure pipeb(0) -text $riione  -justify left
#  $canv itemconfigure pipeb(1) -text $riiones -justify left
  $canv itemconfigure pipebfl(3) -text [string range $ralutwo 0 7]
  $canv itemconfigure pipebfl(2) -text [string range $ralutwo 8 15]
  $canv itemconfigure pipebfl(1) -text [string range $ralutwo 16 23]
  $canv itemconfigure pipebfl(0) -text [string range $ralutwo 24 31]
  } else {
   $canv itemconfigure pipe(1) -fill $col(2)
   $canv itemconfigure pipeb(0) -text ""  -justify left
#  $canv itemconfigure pipeb(1) -text "" -justify left
  $canv itemconfigure pipebfl(3) -text ""
  $canv itemconfigure pipebfl(2) -text ""
  $canv itemconfigure pipebfl(1) -text ""
  $canv itemconfigure pipebfl(0) -text ""
#  $canv itemconfigure pipeb(3) -text "" -justify left
  }
}


# pipetwo --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc pipetwo {nl} {
  variable  msize;
  variable  noslots;
  variable  canv;
  variable  col

  set rmemonein [lindex $nl 0];
  set rmemones  [lindex $nl 1];
  set rmemone   [lindex $nl 2];

  
  $canv itemconfigure pipe(2) -outline $col($rmemones)
  $canv itemconfigure pipeli(2) -fill $col($rmemones)
    if {$rmemones == 1} {
  $canv itemconfigure pipe(2) -fill $col(3) 
  $canv itemconfigure pipec(0) -text $rmemonein  -justify left
#  $canv itemconfigure pipec(1) -text $rmemones -justify left
  $canv itemconfigure pipecfl(3) -text [string range $rmemone 0 7]
  $canv itemconfigure pipecfl(2) -text [string range $rmemone 8 15]
  $canv itemconfigure pipecfl(1) -text [string range $rmemone 16 23]
  $canv itemconfigure pipecfl(0) -text [string range $rmemone 24 31]
    } else {
   $canv itemconfigure pipe(2) -fill $col(2)
     $canv itemconfigure pipec(0) -text ""  -justify left
#  $canv itemconfigure pipec(1) -text "" -justify left
  $canv itemconfigure pipecfl(3) -text ""
  $canv itemconfigure pipecfl(2) -text ""
  $canv itemconfigure pipecfl(1) -text ""
  $canv itemconfigure pipecfl(0) -text ""
    }
}


# rsp --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc rsp {nl} {
  variable  msize;
  variable  noslots;
  variable  canv;
  variable  col;

  set rsp(0) [lindex $nl 0];
  set rsp(1) [lindex $nl 1];
  set rsp(2) [lindex $nl 2]; 
}


# pipethree --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc pipethree {nl} {
  variable  msize;
  variable  noslots;
  variable  canv;
  variable  col;

  set rmemtwoin  [lindex $nl 0];
  set rmemtwos   [lindex $nl 1];
  set rmemtwo    [lindex $nl 2];
  set rmemtwob   [lindex $nl 3];

  
  $canv itemconfigure pipe(3) -outline $col($rmemtwos)
  $canv itemconfigure pipeli(3) -fill $col($rmemtwos)  
    if {$rmemtwos == 1} {
  $canv itemconfigure pipe(3) -fill $col(3)
  $canv itemconfigure piped(0) -text $rmemtwoin  -justify left
#  $canv itemconfigure piped(1) -text $rmemtwos -justify left
  $canv itemconfigure pipedfl(3) -text [string range $rmemtwo 0 7]
  $canv itemconfigure pipedfl(2) -text [string range $rmemtwo 8 15]
  $canv itemconfigure pipedfl(1) -text [string range $rmemtwo 16 23]
  $canv itemconfigure pipedfl(0) -text [string range $rmemtwo 24 31]
  $canv itemconfigure piped(3) -text $rmemtwob -justify left
    } else {
   $canv itemconfigure pipe(3) -fill $col(2)
  $canv itemconfigure piped(0) -text ""  -justify left
#  $canv itemconfigure piped(1) -text "" -justify left
  $canv itemconfigure pipedfl(3) -text ""
  $canv itemconfigure pipedfl(2) -text ""
  $canv itemconfigure pipedfl(1) -text ""
  $canv itemconfigure pipedfl(0) -text ""
  $canv itemconfigure piped(3) -text "" -justify left
    }
}


# pipefour --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc pipefour {nl} {
  variable msize;
  variable noslots;
  variable canv;
  variable col;

  set rstkonein [lindex $nl 0];
  set rstkones  [lindex $nl 1];
  set rstkone   [lindex $nl 2];
  set rstkoneb  [lindex $nl 3];
  set zilock    [lindex $nl 4];

  
  $canv itemconfigure pipe(4) -outline $col($rstkones)
  $canv itemconfigure pipeli(4) -fill $col($rstkones)  
    if {$rstkones == 1 && $zilock == 1} {
  $canv itemconfigure pipe(4) -fill $col(3)
  $canv itemconfigure pipee(0) -text $rstkonein  -justify left
#  $canv itemconfigure pipee(1) -text $rstkones -justify left
  $canv itemconfigure pipeefl(3) -text [string range $rstkone 0 7]
  $canv itemconfigure pipeefl(2) -text [string range $rstkone 8 15]
  $canv itemconfigure pipeefl(1) -text [string range $rstkone 16 23]
  $canv itemconfigure pipeefl(0) -text [string range $rstkone 24 31]
  $canv itemconfigure pipee(3) -text $rstkoneb -justify left
    } else {
        if {$zilock == 0 && $rstkones == 0} {
         $canv itemconfigure pipe(4) -fill $col(2)
  $canv itemconfigure pipee(0) -text ""  -justify left
#  $canv itemconfigure pipee(1) -text "" -justify left
  $canv itemconfigure pipeefl(3) -text ""
  $canv itemconfigure pipeefl(2) -text ""
  $canv itemconfigure pipeefl(1) -text ""
  $canv itemconfigure pipeefl(0) -text ""
  $canv itemconfigure pipee(3) -text "" -justify left
         
        } else { 
          $canv itemconfigure pipe(4) -fill $col(3)
  $canv itemconfigure pipee(0) -text $rstkonein  -justify left
#  $canv itemconfigure pipee(1) -text $rstkones -justify left
  $canv itemconfigure pipeefl(3) -text [string range $rstkone 0 7]
  $canv itemconfigure pipeefl(2) -text [string range $rstkone 8 15]
  $canv itemconfigure pipeefl(1) -text [string range $rstkone 16 23]
  $canv itemconfigure pipeefl(0) -text [string range $rstkone 24 31]
  $canv itemconfigure pipee(3) -text $rstkoneb -justify left
        }
    }
}

# stack --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc stack {nl} {
  variable msize;
  variable noslots;
  variable canv;
  variable col;

  set stkp   [lindex $nl 0];
  set stkbot [lindex $nl 1];
  set stktop [lindex $nl 2]; 
  set stkin  [lindex $nl 3]; 
  set stkfl  [lindex $nl 4];
  set stkb   [lindex $nl 5];

     for {set i 0} {$i<[expr $noslots+1]} {incr i} {
         if {$i == $stkbot} { 
          $canv itemconfigure stki($i) -fill $col(0)
          $canv itemconfigure stka($i) -fill $col(0) 
          $canv itemconfigure stkb($i) -fill $col(0) 
          $canv itemconfigure stkc($i) -fill $col(0) 
          $canv itemconfigure stkd($i) -fill $col(0) 
          $canv itemconfigure stke($i) -fill $col(0) 
          $canv itemconfigure stkf($i) -fill $col(0) 
         } else {
           if {$i == $stktop} { 
            $canv itemconfigure stki($i) -fill $col(4)
            $canv itemconfigure stka($i) -fill $col(4) 
            $canv itemconfigure stkb($i) -fill $col(4) 
            $canv itemconfigure stkc($i) -fill $col(4) 
            $canv itemconfigure stkd($i) -fill $col(4) 
            $canv itemconfigure stke($i) -fill $col(4) 
            $canv itemconfigure stkf($i) -fill $col(4) 
           } else {
               if {$stktop < $stkbot} {
                   if {$i >$stkbot || $i<$stktop} {
                     $canv itemconfigure stki($i) -fill $col(3)
                     $canv itemconfigure stka($i) -fill $col(3) 
                     $canv itemconfigure stkb($i) -fill $col(3) 
                     $canv itemconfigure stkc($i) -fill $col(3) 
                     $canv itemconfigure stkd($i) -fill $col(3) 
                     $canv itemconfigure stke($i) -fill $col(3) 
                     $canv itemconfigure stkf($i) -fill $col(3) 
                   } else {
                     $canv itemconfigure stki($i) -fill $col(5)
                     $canv itemconfigure stka($i) -fill $col(5) -text ""
                     $canv itemconfigure stkb($i) -fill $col(5) -text ""
                     $canv itemconfigure stkc($i) -fill $col(5) -text ""
                     $canv itemconfigure stkd($i) -fill $col(5) -text ""
                     $canv itemconfigure stke($i) -fill $col(5) -text ""
                     $canv itemconfigure stkf($i) -fill $col(5) -text ""
                   }
               } else {
                  if {$i >$stkbot && $i<$stktop} {
                     $canv itemconfigure stki($i) -fill $col(3)
                     $canv itemconfigure stka($i) -fill $col(3) 
                     $canv itemconfigure stkb($i) -fill $col(3) 
                     $canv itemconfigure stkc($i) -fill $col(3) 
                     $canv itemconfigure stkd($i) -fill $col(3) 
                     $canv itemconfigure stke($i) -fill $col(3) 
                     $canv itemconfigure stkf($i) -fill $col(3) 
                  } else {
                     $canv itemconfigure stki($i) -fill $col(5)
                     $canv itemconfigure stka($i) -fill $col(5) -text ""
                     $canv itemconfigure stkb($i) -fill $col(5) -text ""
                     $canv itemconfigure stkc($i) -fill $col(5) -text ""
                     $canv itemconfigure stkd($i) -fill $col(5) -text ""
                     $canv itemconfigure stke($i) -fill $col(5) -text ""
                     $canv itemconfigure stkf($i) -fill $col(5) -text ""
                  }
              }
           }
       }
   }   
  
  $canv itemconfigure stka($stkp) -text $stkin
  $canv itemconfigure stkb($stkp) -text [string range $stkfl 0 7]
  $canv itemconfigure stkc($stkp) -text [string range $stkfl 8 15]
  $canv itemconfigure stkd($stkp) -text [string range $stkfl 16 23]
  $canv itemconfigure stke($stkp) -text [string range $stkfl 24 31]
  $canv itemconfigure stkf($stkp) -text $stkb
  
}




}; # end of namespace epsimnew
