/* -*- Mode: C -*-
 * library of commands to connect with veriwell
 */


define veri_dot() = {
  empty and format("\n!E: veri0 dot:\n")
}.

define veri_dot_ne() = {
   format("\n!E: veri0 dot:\n")
}.

define block_assign(X,Y) = {
  empty and format("\n!E: veri0 %s:\n",X+"="+str(Y))
}.

define block_assign_ne(X,Y) = {
   format("\n!E: veri0 %s:\n",X+"="+str(Y))
}.

define non_block_assign(X,Y) = {
  empty and format("\n!E: veri0 %s:\n",X+"<="+str(Y))
}.

define non_block_assign_ne(X,Y) = {
   format("\n!E: veri0 %s:\n",X+"<="+str(Y))
}.

define veri(X) = {
  empty and format("\n!E: veri0 %s:\n",X)
}.

define finish() = 
{
 empty and format("\n!E: veri0 finish:\n")
}.

define veri_ne(X) = {
   format("\n!E: veri0 %s:\n",X)
}.


define t_block_assign(T,X,Y) = {
  empty and format("\n!E: veri0 %s:\n","#"+str(T)+" "+X+"="+str(Y))
}.

define t_block_assign_ne(T,X,Y) = {
   format("\n!E: veri0 %s:\n","#"+str(T)+" "+X+"="+str(Y))
}.

define t_non_block_assign(T,X,Y) = {
  empty and format("\n!E: veri0 %s:\n","#"+str(T)+" "+X+"<="+str(Y))
}.

define t_non_block_assign_ne(T,X,Y) = {
   format("\n!E: veri0 %s:\n","#"+str(T)+" "+X+"<="+str(Y))
}.


define p_veri_dot(Z) = {
  empty and format("\n!E: veri%s dot:\n",str(Z))
}.

define p_veri_dot_ne(Z) = {
   format("\n!E: veri%s dot:\n",str(Z))
}.

define p_block_assign(Z,X,Y) = {
  empty and format("\n!E: veri%s %s:\n",str(Z),X+"="+str(Y))
}.

define p_block_assign_ne(Z,X,Y) = {
   format("\n!E: veri%s %s:\n",str(Z),X+"="+str(Y))
}.

define p_non_block_assign(Z,X,Y) = {
  empty and format("\n!E: veri%s %s:\n",str(Z),X+"<="+str(Y))
}.

define p_non_block_assign_ne(Z,X,Y) = {
   format("\n!E: veri%s %s:\n",str(Z),X+"<="+str(Y))
}.

define p_veri(Z,X) = {
  empty and format("\n!E: veri%s %s:\n",str(Z),X)
}.

define p_finish(Z) = 
{
 empty and format("\n!E: veri%s finish:\n",str(Z))
}.

define p_stop(Z) = 
{
 empty and format("\n!E: veri%s stop0:\n",str(Z))
}.
define p_stop_ne(Z) = 
{
 format("\n!E: veri%s stop0:\n",str(Z))
}.
define p_veri_ne(Z,X) = {
   format("\n!E: veri%s %s:\n",str(Z),X)
}.

define t_p_block_assign(Z,T,X,Y) = {
  empty and format("\n!E: veri%s %s:\n",str(Z),"#"+str(T)+" "+X+"="+str(Y))
}.

define t_p_block_assign_ne(Z,T,X,Y) = {
   format("\n!E: veri%s %s:\n",str(Z),"#"+str(T)+" "+X+"="+str(Y))
}.

define t_p_non_block_assign(Z,T,X,Y) = {
  empty and format("\n!E: veri%s %s:\n",str(Z),"#"+str(T)+" "+X+"<="+str(Y))
}.

define t_p_non_block_assign_ne(Z,T,X,Y) = {
   format("\n!E: veri%s %s:\n",str(Z),"#"+str(T)+" "+X+"<="+str(Y))
}.

define t_p_stop(Z,T) = 
{
 empty and format("\n!E: veri%s %s:\n",str(Z),"stop"+str(T))
}.

define t_p_stop_ne(Z,T) = 
{
 format("\n!E: veri%s %s:\n",str(Z),"stop"+str(T))
}.
