/* -*- Mode: C -*-
 * Simple simulation of an SR-latch.  
 * Ben Moszkowski. 
 * 21 Apr 85 
 *
 */
 
/* run */ define latch_test() = exists S,R,Q,Qbar: {
    S=0 and R=0 and Q=0 and Qbar=0
    and for l in [[1,0],[0,0],[0,1],[1,0],[0,0]] do {
	len(5)
	and S gets l[0] and R gets l[1]
    }
    and Q gets not(R or Qbar)
    and Qbar gets not(S or Q)
    and format("%4S %3S  %3S  %3S\n","Qbar"," Q "," R "," S ")
    and always format("%3S  %3S  %3S  %3S\n",wave(Qbar),wave(Q),wave(R),wave(S))
}.

define wave(A) = {
    if A=0 then "|  " else " | "
}.

