/* -*- Mode: C -*-
 * Test of prefix operator.  
 * Ben Moszkowski  
 * 12 Aug 85 
 */


/* set(future_asgn_flag,false). */

/* run */ define simple_test() = {
    len(3)
    and prefix({
	len(5) and always output(1)
    })
}.

/* run */ define gets_test() = exists I: {
    halt(I=16)
    and prefix(I=1 and I gets 2*I and len(10))
    and always format("I=%3d\n",I)
}.

/* run */ define sum_test(t) = {
    exists Tree, Status : {
	{
	    Tree=t and Status=[]
	    and halt (|Status|=1)
	    and prefix(sum_tree(Status,Tree))
	    and always format("Status=%7t  Tree=%t\n",Status,Tree)
	}
    }
}.

define sum_tree(Status,Tree) = {
    sum_tree_body(Status,Tree);
    {
	skip and Status := [true] and stable Tree
    }
}.

define sum_tree_body(Status,Tree) = {
    if is_integer(Tree) then {
	if Tree > 0 then empty
	else {
	    skip and Status:=[false] and stable Tree
	}
    }
    else {
	sum_subtree(Status,Tree,0);
	sum_subtree(Status,Tree,1);
	{
	    skip and Tree:= Tree[0]+Tree[1] and stable(Status)
	}
    }
}.

/* Sum the i-th subtree.  Keep the other subtree stable */
define sum_subtree(Status,Tree,i) = {
    sum_tree_body(Status,Tree[i])
    and stable_struct(Tree)
    and stable Tree[1-i]
}.


define sum_test1 = [[[1,1],[1,1]],[[1,1],[1,1]]].

define sum_test2 = [[[1,1],[1,1]],[[0,1],[1,1]]].

