/* -*- Mode: C -*-
 * A pulse-generating circuit.  
 * Ben Moszkowski  
 * 28 Oct 84
 * Updated 16 Jan 85 
 */

define wave(A) = {
    if A=0 then "|  " else " | "
}.

/* run */ define pulse_test() = exists W,X,Y,Z: {
    W=0 and X=0 and Y=0 and
    for 5 times do {
	{
	    len(3) and stable W
	};
	{
	    skip and W:=not W
	}
    }
    and {X gets W} and {Y gets X} and {Z is (W and X and Y)}
    and format("%3s  %3s  %3s  %3s\n","Z","Y","X","W")
    and box format("%3s  %3s  %3s  %3s\n",wave(Z),wave(Y),wave(X),wave(W))
}.
